var Amaze = require('../lib/amaze');

suite('Visit Google to search', function() {

    test('it can navigate to the Google search homepage', function() {
        return Amaze.Browser.get('https://www.google.com');
    });

    test('it has the correct title', function() {
        return Amaze.Browser.getTitle().then(function(title) {
            Amaze.Expect(title).to.equal('Google');
        })
    });

    test('it can find the search box', function() {
        return Amaze.Browser.findElement(Amaze.By.name('q')).then(function(search) {
            Amaze.Expect(search).to.not.be.null;
        });
    });

    test('it can perform a search', function() {
        return Amaze.Browser.get('https://www.google.com/?noj=1').then(function() {
            return Amaze.Browser.findElement(Amaze.By.name('q')).then(function(search) {
                return search.sendKeys('Deque accessibility').then(function() {
                    search.sendKeys(Amaze.Webdriver.Key.ENTER);
                    return Amaze.Browser.getTitle().then(function(title) {
                        Amaze.Expect(title).to.equal('Deque accessibility - Google Search');
                    });
                });
            });
        });
    });

    suiteTeardown(function(done) {
        Amaze.Browser.quit().then(done);
    });
});